<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Mensagens_model extends CI_Model {

    public $id;
    public $titulo;

    public function __construct(){
        parent::__construct();
    }
    
    //Listo as mensagens na página de mensagens do admin
    public function listar_mensagens(){
        $this->db->select('
            *
        ');
        $this->db->from('mensagens');
        $this->db->order_by('mensagens.id', 'DESC');
        return $this->db->get('')->result();
    }


    //Busco a lista de usuários e id
    public function listar_usuarios(){
        $this->db->select('
            *
        ');
        $this->db->from('usuarios');
        $this->db->order_by('usuarios.nome', 'ASC');
        return $this->db->get('')->result();
    }
   
    public function publica_mensagem($titulo, $mensagem, $status, $enviar_para, $usuario) {
        // Adiciona a Mensagem
        $data = Date("Y-m-d H:i:s");
        $armazena_mensagem['titulo'] = $titulo;
        $armazena_mensagem['conteudo'] = $mensagem;
        $armazena_mensagem['status'] = $status;
        $armazena_mensagem['data'] = $data;
        $this->db->insert('mensagens', $armazena_mensagem);

        //Pega o id da mensagem para usar na tabela de mensagens_usuários
        $this->db->select('
            id
        ');
        $this->db->from('mensagens');
        $this->db->order_by('mensagens.id', 'DESC');
        $this->db->limit(1);
        $query_mensagens = $this->db->get('')->result();
        $id_postagem = $query_mensagens[0]->id;

        //Insere na tabela mensagens_usuários quais usuários vao ver a mensagem
        if($enviar_para == 'todos') {
            $linhasusuarios = $this->mensagensmodel->listar_usuarios();
            foreach ($linhasusuarios as $linha_usuario)  {
                $armazena_mensagem_usuario['id_usuario'] = $linha_usuario->id;
                $armazena_mensagem_usuario['id_postagem'] = $id_postagem;
                $this->db->insert('mensagens_usuarios', $armazena_mensagem_usuario);
            };
            $this->session->set_flashdata('mensagem','sucesso');
            redirect(base_url('admin/mensagens'));
        }else{
            foreach ($usuario as $item)  {
                $armazena_mensagem_usuario['id_usuario'] = $item;
                $armazena_mensagem_usuario['id_postagem'] = $id_postagem;
                $this->db->insert('mensagens_usuarios', $armazena_mensagem_usuario);
            };
            $this->session->set_flashdata('mensagem','sucesso');
            redirect(base_url('admin/mensagens'));
        }
    }


    public function deleta_mensagem($id) {
        //$this->db->where('md5(id)',$id);
         //return $this->db->delete('vendas');
 
         $sqlUpdate = "delete from mensagens where id = " .$id;
         $this->db->query($sqlUpdate);

         $sqlUpdate = "delete from mensagens_usuarios where id_postagem = " .$id;
         $this->db->query($sqlUpdate);
 
         return TRUE;
     }


/*  Recurso desativado
     public function editar_mensagem_admin($id) {

        $this->db->select('
            mensagens.id as idmensagem,
            mensagens.titulo,
            mensagens.conteudo,
            mensagens.data,
            mensagens.status
            '
        );
        $this->db->from('mensagens');
        $this->db->order_by('mensagens.id','DESC');
        $this->db->where('mensagens.id ='.$id);
        $resultado = $this->db->get('')->result();
        //var_dump ($resultado);

        return $resultado;
    }
*/



//
//
//
//Frontend
//
//
//

    public function listar_mensagens_usuario($id_usuario) {
        $this->db->select('
            mensagens.id as idmensagem,
            mensagens.titulo,
            mensagens.conteudo,
            mensagens.data,
            mensagens.status,
            mensagens_usuarios.visualizado,
            mensagens_usuarios.id'
        );
        $this->db->from('mensagens');
        $this->db->join('mensagens_usuarios','mensagens_usuarios.id_postagem = mensagens.id');
        $this->db->order_by('mensagens.id','DESC');
        $this->db->where('mensagens_usuarios.id_usuario ='.$id_usuario);
        $this->db->where('mensagens.status = 1');
        return $this->db->get('')->result();
    }


    public function visualizar_mensagem($id, $id_usuario) {

        $this->db->select('
            mensagens.id as idmensagem,
            mensagens.titulo,
            mensagens.conteudo,
            mensagens.data,
            mensagens.status,
            mensagens_usuarios.visualizado,
            mensagens_usuarios.id
            '
        );
        $this->db->from('mensagens');
        $this->db->join('mensagens_usuarios','mensagens_usuarios.id_postagem = mensagens.id');
        $this->db->order_by('mensagens.id','DESC');
        $this->db->where('mensagens_usuarios.id_usuario ='.$id_usuario);
        $this->db->where('mensagens_usuarios.id ='.$id);
        $this->db->where('mensagens.status = 1');
        $resultado = $this->db->get('')->result();
        //var_dump ($resultado);

        //aqui eu verifico se o cliente ja 
        if(!$resultado == null) {
            if($resultado[0]->visualizado == 'N') {
                $atualiza_status = "update mensagens_usuarios set visualizado = 'S' where id_usuario = " .$id_usuario ." and id= " .$id;
                $this->db->query($atualiza_status);
            }else{
                return $resultado;
            }
        } else {
            return $resultado;
        }
        return $resultado;
    }


    //Soma do numero total de vendas
    public function contador_mensagens_nao_lidas($id_usuario) {
        $this->db->select('
            count(mensagens_usuarios.id) as numero_mensagens_nao_lidas
        ');
        $this->db->from('mensagens_usuarios');
        $this->db->join('mensagens','mensagens.id = mensagens_usuarios.id_postagem');
        $this->db->where('mensagens_usuarios.id_usuario ='.$id_usuario);
        $this->db->where('mensagens_usuarios.visualizado', 'N');
        $this->db->where('mensagens.status = 1');
        $this->db->limit(1);
        return $this->db->get('')->result();
    }

}
